Package net.shibboleth.idp.authn.impl

# Class DoLockoutManagerOperation

java.lang.Object
net.shibboleth.shared.component.AbstractInitializableComponent
org.opensaml.profile.action.AbstractProfileAction
org.opensaml.profile.action.AbstractConditionalProfileAction
net.shibboleth.idp.profile.AbstractProfileAction
net.shibboleth.idp.authn.impl.DoLockoutManagerOperation

All Implemented Interfaces:
  `Component`, `DestructableComponent`, `InitializableComponent`, `ProfileAction`, `Aware`, `MessageSource`, `MessageSourceAware`, `Action`

public class DoLockoutManagerOperation extends AbstractProfileAction
Action that implements a JSON REST API for the `AccountLockoutManager` interface.

The API supports GET, POST, and DELETE at the moment, using jsonapi.org conventions.

GET
  Check for lockout.
POST
  Increment lockout.
DELETE
  Clear lockout count.

Event:
  `EventIds.PROCEED_EVENT_ID`, `EventIds.INVALID_PROFILE_CTX`, `EventIds.IO_ERROR`

## Field Summary

Fields
Modifier and Type
Field
Description
`private boolean`
`inexact`
Enumerating on inexact matches?
`static final String`
`INEXACT`
Flow variable indicating whether key should be inexactly matched.
`private String`
`key`
Account key to operate on.
`static final String`
`KEY`
Flow variable indicating ID of account key.
`private AccountLockoutManager`
`lockoutManager`
`AccountLockoutManager` to operate on.
`private org.slf4j.Logger`
`log`
Class logger.
`static final String`
`MANAGER_ID`
Flow variable indicating ID of manager bean to access.
`private String`
`managerId`
Manager ID to operate on.
`private com.fasterxml.jackson.databind.ObjectMapper`
`objectMapper`
JSON object mapper.

## Constructor Summary

Constructors
Constructor
Description
`DoLockoutManagerOperation()`

## Method Summary

Modifier and Type
Method
Description
`protected void`
`doExecute(ProfileRequestContext profileRequestContext)`
`protected void`
`doInitialize()`
`protected boolean`
`doPreExecute(ProfileRequestContext profileRequestContext)`
`private AccountLockoutManager`
`getLockoutManager()`
Null safe getter.
`private void`
`sendError(int status, String title, String detail)`
Output an error object.
`void`
`setObjectMapper(com.fasterxml.jackson.databind.ObjectMapper mapper)`
Set the JSON `ObjectMapper` to use for serialization.
`private AccountLockoutManager`
`setupLockoutManager(RequestContext requestContext)`
Helper method to get the manager bean to operate on.

### Methods inherited from class net.shibboleth.idp.profile.AbstractProfileAction

`doExecute, execute, getBean, getBean, getMessage, getMessage, getMessage, getParameter, getParameter, getProfileContextLookupStrategy, getRequestContext, getResult, setMessageSource, setProfileContextLookupStrategy`

### Methods inherited from class org.opensaml.profile.action.AbstractConditionalProfileAction

`getActivationCondition, setActivationCondition`

### Methods inherited from class org.opensaml.profile.action.AbstractProfileAction

`doPostExecute, doPostExecute, ensureHttpServletRequest, ensureHttpServletResponse, execute, getHttpServletRequest, getHttpServletRequestSupplier, getHttpServletResponse, getHttpServletResponseSupplier, getLogPrefix, isPreExecuteCalled, setHttpServletRequestSupplier, setHttpServletResponseSupplier`

### Methods inherited from class net.shibboleth.shared.component.AbstractInitializableComponent

`checkComponentActive, checkSetterPreconditions, destroy, doDestroy, ifDestroyedThrowDestroyedComponentException, ifInitializedThrowUnmodifiabledComponentException, ifNotInitializedThrowUninitializedComponentException, initialize, isDestroyed, isInitialized`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface net.shibboleth.shared.component.InitializableComponent

`initialize, isInitialized`

## Field Details

### MANAGER_ID

@Nonnull @NotEmpty public static final String MANAGER_ID
Flow variable indicating ID of manager bean to access.

See Also:
  - Constant Field Values

### KEY

@Nonnull @NotEmpty public static final String KEY
Flow variable indicating ID of account key.

See Also:
  - Constant Field Values

### INEXACT

@Nonnull @NotEmpty public static final String INEXACT
Flow variable indicating whether key should be inexactly matched.

See Also:
  - Constant Field Values

### log

@Nonnull private org.slf4j.Logger log
Class logger.

### objectMapper

@NonnullAfterInit private com.fasterxml.jackson.databind.ObjectMapper objectMapper
JSON object mapper.

### managerId

@Nullable @NotEmpty private String managerId
Manager ID to operate on.

### key

@NonnullBeforeExec @NotEmpty private String key
Account key to operate on.

### inexact

private boolean inexact
Enumerating on inexact matches?

### lockoutManager

@NonnullBeforeExec private AccountLockoutManager lockoutManager
`AccountLockoutManager` to operate on.

## Constructor Details

### DoLockoutManagerOperation

public DoLockoutManagerOperation()

## Method Details

### setObjectMapper

public void setObjectMapper(@Nonnull com.fasterxml.jackson.databind.ObjectMapper mapper)
Set the JSON `ObjectMapper` to use for serialization.

Parameters:
  `mapper` - object mapper

### doInitialize

protected void doInitialize() throws ComponentInitializationException

Overrides:
  `doInitialize` in class `AbstractInitializableComponent`
Throws:
  `ComponentInitializationException`

### doPreExecute

protected boolean doPreExecute(@Nonnull ProfileRequestContext profileRequestContext)

Overrides:
  `doPreExecute` in class `AbstractConditionalProfileAction`

### doExecute

protected void doExecute(@Nonnull ProfileRequestContext profileRequestContext)

Overrides:
  `doExecute` in class `AbstractProfileAction`

### setupLockoutManager

@Nullable private AccountLockoutManager setupLockoutManager(@Nonnull RequestContext requestContext)
Helper method to get the manager bean to operate on.

Parameters:
  `requestContext` - current SWF request context
Returns:
  lockout manager or null

### getLockoutManager

@Nonnull private AccountLockoutManager getLockoutManager()
Null safe getter.

Returns:
  Returns the lockoutManager.

### sendError

private void sendError(int status, @Nonnull @NotEmpty String title, @Nonnull @NotEmpty String detail) throws IOException
Output an error object.

Parameters:
  `status` - HTTP status
  `title` - fixed error description
  `detail` - human-readable error description
Throws:
  `IOException` - if unable to output the error